MAX_CALLBACK = 10

$out  ||= $stdout
$dl_h = ARGV[0] || "dl.h"

# import DLSTACK_SIZE, DLSTACK_ARGS and so on
File.open($dl_h){|f|
  pre = ""
  f.each{|line|
    line.chop!
    if( line[-1] == ?\ )
      line.chop!
      line.concat(" ")
      pre += line
      next
    end
    if( pre.size > 0 )
      line = pre + line
      pre  = ""
    end
    case line
    when /#define\s+DLSTACK_SIZE\s+\(?(\d+)\)?/
      DLSTACK_SIZE = $1.to_i
    when /#define\s+DLSTACK_ARGS\s+(.+)/
      DLSTACK_ARGS = $1.to_i
    when /#define\s+DLTYPE_([A-Z_]+)\s+\(?(\d+)\)?/
      eval("#{$1} = #{$2}")
    when /#define\s+MAX_DLTYPE\s+\(?(\d+)\)?/
      MAX_DLTYPE  = $1.to_i
    end
  }
}

DLTYPE = {
  VOID => {
    :name => 'void',
    :type => 'void',
    :conv => "",
  },
  CHAR => {
    :name => 'char',
    :type => 'char',
    :conv => 'NUM2CHR(%s)'
  },
  SHORT => {
    :name => 'short',
    :type => 'short',
    :conv => 'NUM2INT(%s)',
  },
  INT => {
    :name => 'int',
    :type => 'int',
    :conv => 'NUM2INT(%s)',
  },
  LONG  => {
    :name => 'long',
    :type => 'long',
    :conv => 'NUM2LONG(%s)',
  },
  LONG_LONG => {
    :name => 'long_long',
    :type => 'LONG_LONG',
    :conv => 'NUM2LL(%s)',
  },
  FLOAT => {
    :name => 'float',
    :type => 'float',
    :conv => 'RFLOAT(%s)->value',
  },
  DOUBLE => {
    :name => 'double',
    :type => 'double',
    :conv => 'RFLOAT(%s)->value',
  },
  VOIDP => {
    :name => 'ptr',
    :type => 'void *',
    :conv => 'NUM2PTR(%s)',
  },
}


def func_name(ty, n)
  "rb_dl_callback_#{DLTYPE[ty][:name]}_#{n}"
end

$out << (<<EOS)
#define MAX_CALLBACK #{MAX_CALLBACK}
VALUE rb_DLCallbackAddrs, rb_DLCallbackProcs;
static void *callbacks[MAX_DLTYPE][MAX_CALLBACK];
static ID   cb_call;
EOS

for ty in 0..(MAX_DLTYPE-1)
  for n in 0..(MAX_CALLBACK-1)
    $out << (<<-EOS)

static #{DLTYPE[ty][:type]}
#{func_name(ty,n)}(#{(0...DLSTACK_SIZE).collect{|i| "DLSTACK_TYPE stack" + i.to_s}.join(", ")})
{
    int i;
    VALUE args[DLSTACK_SIZE];
    VALUE ret, cb;
#{
      (0...DLSTACK_SIZE).collect{|i|
	"    args[%d] = DLLONG2NUM(stack%d);" % [i,i]
      }.join("\n")
}
    cb = rb_ary_entry(rb_ary_entry(rb_DLCallbackProcs, #{ty}), #{n});
    ret = rb_funcall2(cb, cb_call, DLSTACK_SIZE, args);
    return #{DLTYPE[ty][:conv] % "ret"};
}

    EOS
  end
end

$out << (<<EOS)
static void
rb_dl_init_callbacks()
{
    int i, j;

    cb_call = rb_intern("call");		       

    rb_DLCallbackProcs = rb_ary_new();
    rb_DLCallbackAddrs = rb_ary_new();
    rb_define_const(rb_mDL, "CallbackProcs", rb_DLCallbackProcs);
    rb_define_const(rb_mDL, "CallbackAddrs", rb_DLCallbackAddrs);
#{
    (0...MAX_DLTYPE).collect{|ty|
      sprintf("    rb_ary_push(rb_DLCallbackProcs, rb_ary_new3(%d,%s));",
	      MAX_CALLBACK, (0...MAX_CALLBACK).collect{ "Qnil" }.join(","))
    }.join("\n")
}
#{
    (0...MAX_DLTYPE).collect{|ty|
      sprintf("    rb_ary_push(rb_DLCallbackAddrs, rb_ary_new3(%d,%s));",
	      MAX_CALLBACK, (0...MAX_CALLBACK).collect{|i| "PTR2NUM(%s)" % func_name(ty,i) }.join(","))
    }.join("\n")
}
}
EOS
